* World Politics Revision
* February 9, 2013
* April 17, 2013--adding new variable to proxy for rad right support.


cd "/users/dal7w/dropbox/defying/archive/migration2010"


use "/Users/dal7w/Dropbox/Defying/Archive/migration2010/wp_replication_data.dta", clear
gen lflow2=lflow

replace lflow2=log(0.00001) if flow==0

capture drop Llgdp* 
capture drop Llpop*

foreach var of varlist lpopulation_d lpopulation_o lgdppc_ppp_o lgdppc_ppp_d {
	gen L`var' = l.`var'
	}

**add new rad right variables
merge m:m ifs_d year using "/Users/dal7w/Dropbox/Defying/Archive/migration2010/jen_april_update"
drop _m
drop if dyad==.
tsset dyad year

recode lang 0=1 1=0
genl L5citizen=l5.citizen
genl L5language=L5.lang
replace res_dum = l.res_dum if res_dum==. & l.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.
replace res_dum = f.res_dum if res_dum==. & f.res_dum~=.

genl L5res_dum=l5.res_dum

*Create rights variable
* create measure of migrant rights

gen rights=res_dum + (2*dual_cit) + (2*lang) +(2*citizen)
gen L5rights=l5.rights

qui areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights i.ifs_d, abs(DOY) robust
keep if e(sample)

foreach var of varlist mig_none_drag mig_open_drag lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5rights L5NRT {
	egen mean_`var'_time=mean(`var'), by(year)
	gen demean_`var'=mean_`var'_time-`var'
	}
	
foreach var of varlist mig_none_drag mig_open_drag lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5rights L5NRT {
	egen mean_`var'_time_O=mean(demean_`var'), by(ifs_o)
	gen c_`var'=mean_`var'_time_O-demean_`var'
	}


*Baseline
* Origin * Year FE and Destination FE
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy i.ifs_d, abs(DOY) robust
est store A
*Add Political Variables--one at a time
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT i.ifs_d, abs(DOY) robust
est store B
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5res_dum i.ifs_d, abs(DOY) robust
est store C
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5dual i.ifs_d, abs(DOY) robust
est store D
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5citizen i.ifs_d, abs(DOY) robust
est store E
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5language i.ifs_d, abs(DOY) robust
est store F
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5rights i.ifs_d, abs(DOY) robust
est store G
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights i.ifs_d, abs(DOY) robust
est store GG


label var lflow "Log(Bilateral Migrant Flows)"
label var lIstock "Log(Bilateral Migrant Stock)"
label var ldist "Log(Bilateral Distance)"
label var contig "Shared Border"
label var colony "Common Colonial Origin"
label var comlang_off "Common Official Language"
label var Llpopulation_d "Log(Population Dest)"
label var Ldiff "Income Differential"
label var Lunemp "Unemployment Dest"
label var Lleblangpolicy "Migration Policy Restrictions"
label var L5policy "View of Migration Policy"
label var L5NRT "Right Wing Party Vote"
label var L5rights "Immigrant Rights"
label var L5res_dum "Residency Requirement"
label var L5lang "No Language Requirement"
label var L5citi "Citizenship by Birth"
label var L5dual "Dual Citizenship"

esttab A B C D E F G GG, label se onecell ar2 star(* 0.10 ** 0.05 ) drop(*ifs* ) b(3) se(3), using table1.rtf, replace


xi: estsimp reg c_lflow c_lIstock c_ldistcap c_contig c_colony c_comlang_off c_Llpopulation_d c_Ldiff c_Lunemp c_Lleblangpolicy c_L5policy c_L5rights c_L5NRT i.ifs_d, robust
setx mean
plotfds, discrete(c_contig c_colony c_comlang_off) continuous(c_ldist c_lIstock c_Lunemp  c_L5NRT c_L5rights) nosetx sort(c_L5rights c_ldist c_lIstock c_Lunemp ) clevel(90) xline(0) ylab(none, axis(2)) saving(predictions1.gph,replace)


* Interactions

genl RLunemp=L5rights*Lunemp
qui areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights RLunemp  i.ifs_d  , abs(DOY) robust
est store K
grinter Lunemp, inter(RLunemp) cons(L5rights) nomean yline(0) saving(marginals1.gph, replace)

genl RLdist=L5rights*ldist
qui areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights RLdist  i.ifs_d  , abs(DOY) robust
est store L
grinter ldist, inter(RLdist) cons(L5rights) nomean yline(0) saving(marginals2.gph, replace)

label var RLunemp "Rights * Unemployment"
label var RLdist "Rights * Log(Distance)"

esttab K L , label se onecell ar2 star(* 0.10 ** 0.05 ) drop(*ifs* ) b(3) se(3), using table3.rtf, replace



***************************
* Robustness Checks

* Dyad Fixed Effects and year fixed effects
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights i.year, abs(dyad) robust
est store H

tab year, gen(Year)
* XTABOND -- differences out dyad fixed effects
    xtdpdsys lflow lIstock Year*,  pre(Llpopulation_d Llpopulation_o Ldiff Lunemp) endog(L5policy Lleblangpolicy L5NRT L5rights)   maxlags(5)
    est store J

esttab H J, label se onecell ar2 star(* 0.10 ** 0.05 ) drop(*year*) b(3) se(3), using table2.rtf, replace


* Negative Binomial -- PA model
xtnbreg flow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights i.year, pa nolog 
est store M

margins , dydx(lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp L5policy Lleblangpolicy L5NRT L5rights) predict(rate) atmeans
outreg using nbreg1, varlabels marginal replace starlevels(10 5 1) se starloc(1)


****Negative Binomial--random effects as per Allison
version 10.0
xtnbreg flow c_lIstock c_ldistcap c_contig c_colony c_comlang_off c_Llpopulation_d c_Ldiff c_Lunemp c_Lleblangpolicy c_L5policy c_L5rights c_L5NRT ,  nolog re
mfx, predict(nu0)

est store N


esttab M N , label se onecell ar2 star(* 0.10 ** 0.05 ) b(3) se(3), using table4.rtf, replace

***
*Alternative measures of Radical Right Wing Party -- for appendix
gen xrtdum=0
replace xrtdum=1 if xrt1_vote>=15
gen cmpdum=0
replace cmpdum=1 if cmp_mcult_score_x1>0
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy i.l5.xrtdum#i.l5.cmpdum L5rights i.ifs_d, abs(DOY) robust
est store P
margins, at(l5.xrtdum=(0(1)1) l5.cmpdum=(0(1)1))

*Substitute other variables for NRTvote
areg lflow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy l5.no_immig_nbrs_drag L5rights i.ifs_d, abs(DOY) robust
est store Q

esttab P Q , label se onecell ar2 star(* 0.10 ** 0.05 ) b(3) se(3) drop(*ifs*), using table5.rtf, replace


**********************************************************************************************************************************************************************************
**********************************************************************************************************************************************************************************
**********************************************************************************************************************************************************************************
*******  Predictions**************************************************************************************************************************************************************
**********************************************************************************************************************************************************************************
**********************************************************************************************************************************************************************************
**********************************************************************************************************************************************************************************





*Predictions based on model G
xtnbreg flow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights i.year, pa nolog 
*margins , at(L5right=(0 4 8)) over(ifs_d) predict(rate) post

***Predictions for each country over time based on xtnbreg model: varying political rights*****
margins if ifs_d==111, at(L5right=(0 4 8)) over(year) predict(rate)
marginsplot, xdimension(year) recast(line) plot1opts(lpattern(solid)) plot2opts(lpattern(dash)) plot3opts(lpattern(longdash_dot)) recastci(rarea) ytitle(Predicted Inflows) xtitle("") title("Predicted Inflows: USA") legend(on)

margins if ifs_d==134, at(L5right=(0 4 8)) over(year) predict(rate)
marginsplot, xdimension(year) recast(line) plot1opts(lpattern(solid)) plot2opts(lpattern(dash)) plot3opts(lpattern(longdash_dot)) recastci(rarea) ytitle(Predicted Inflows) xtitle("") title("Predicted Inflows: Germany") legend(on)

margins if ifs_d==112, at(L5right=(0 4 8)) over(year) predict(rate)
marginsplot, xdimension(year) recast(line) plot1opts(lpattern(solid)) plot2opts(lpattern(dash)) plot3opts(lpattern(longdash_dot)) recastci(rarea) ytitle(Predicted Inflows) xtitle("") title("Predicted Inflows: UK") legend(on)

*Vary NRT--Austria
margins if ifs_d==122, at(L5NRT=(0 12 25)) over(year) predict(rate)
marginsplot, xdimension(year) recast(line) plot1opts(lpattern(solid)) plot2opts(lpattern(dash)) plot3opts(lpattern(longdash_dot)) recastci(rarea) ytitle(Predicted Inflows) xtitle("") title("Predicted Inflows: Austria") legend(on)

*Vary NRT--Germany
margins if ifs_d==134, at(L5NRT=(0 12 25)) over(year) predict(rate)
marginsplot, xdimension(year) recast(line) plot1opts(lpattern(solid)) plot2opts(lpattern(dash)) plot3opts(lpattern(longdash_dot)) recastci(rarea) ytitle(Predicted Inflows) xtitle("") title("Predicted Inflows: Austria") legend(on)


* Want to get predictions based on status quo L5rights then highest and lowest
xtnbreg flow lIstock ldist contig colony comlang_off Llpopulation_d Ldiff Lunemp Lleblangpolicy L5policy L5NRT L5rights i.year, pa nolog 
margins , at(L5right=(0 4 8)) over(ifs_d)  post

*Create new variables to hold predictions
gen countryno=.
gen Nobs=.
gen P1=.
gen P2=.
gen P3=.

replace countryno=111 in 1
replace countryno=112 in 2
replace countryno=122 in 3
replace countryno=124 in 4
replace countryno=128 in 5
replace countryno=132 in 6
replace countryno=134 in 7
replace countryno=136 in 8
replace countryno=138 in 9
replace countryno=142 in 10
replace countryno=144 in 11
replace countryno=146 in 12
replace countryno=156 in 13
replace countryno=158 in 14
replace countryno=172 in 15
replace countryno=184 in 16
replace countryno=193 in 17
replace countryno=196 in 18

lab def ifs 111 "USA"
lab def ifs 112 "UK", add
lab def ifs 122 "AUT", add
lab def ifs 124 "BEL", add
lab def ifs 128 "DEN", add
lab def ifs 132 "FRA", add
lab def ifs 134 "GER", add
lab def ifs 136 "ITA", add
lab def ifs 138 "NET", add
lab def ifs 142 "NOR", add
lab def ifs 144 "SWE", add
lab def ifs 146 "SWZ", add
labe def ifs 156 "CAN", add
lab def ifs 158 "JAP", add
label def ifs 172 "IRE", add
label def ifs 184 "SPA", add
label def ifs 193 "AUS", add
label def ifs 196 "NZA", add





foreach num of numlist 111 112 122 124 128 132 134 136 138 142 144 146 156 158 172  184 193 196 {
	sum year if e(sample) & ifs_d==`num'
	replace Nobs=r(N) if countryno==`num'
	replace P1=_b[1._at#`num'.ifs_d] if countryno==`num'
	replace P2=_b[2._at#`num'.ifs_d] if countryno==`num'
	replace P3=_b[3._at#`num'.ifs_d] if countryno==`num'
	}
	
*replace P1=P1*Nobs
*replace P2=P2*Nobs
*replace P3=P3*Nobs

keep countryno Nobs P1 P2 P3
gen p1=int(P1)
gen p2=int(P2)
gen p3=int(P3)
drop P1 P2 P3
save predicttable,replace

*convert for a table
keep in 1/18

reshape long p, i(countryno) j(index)

label values countryno ifs
label var p "Predicted Migrant Inflows (2000)"
rename index PolRights
label var PolRights "Immigrant Political Rights Index"
replace PolRights=0 if PolRights==1
replace PolRights=4 if PolRights==2
replace PolRights=8 if PolRights==3

twoway (connect p PolRights), by(countryno)




